package shared

import (
	"github.com/google/uuid"
	"github.com/nrednav/cuid2"
	"github.com/rs/xid"

	"git.mstar.dev/mstar/linstrom/config"
)

// Generate a new string ID
func NewId() string {
	switch config.GlobalConfig.Experimental.IdGenerator {
	case "uuid":
		return uuid.NewString()
	case "cuid":
		return cuid2.Generate()
	case "xid":
		return xid.New().String()
	default:
		return xid.New().String()
	}
}
