package shared

import (
	"github.com/rs/zerolog"
)

// Not testable since it focuses entirely on the side effect of
// sending a log out
func Trace(l *zerolog.Logger) *zerolog.Logger {
	if e := l.Trace(); e.Enabled() {
		e.Caller(2).
			Msg("Entered function")
	}
	return l
}

// Not testable since it focuses entirely on the side effect of
// sending a log out
func Untrace(l *zerolog.Logger) {
	if e := l.Trace(); e.Enabled() {
		e.Caller(2).
			Msg("Exited function")
	}
}
