package models

import "database/sql/driver"

type ActivitystreamsActivityTargetType uint32

const (
	ActivitystreamsActivityTargetUnknown ActivitystreamsActivityTargetType = iota
	ActivitystreamsActivityTargetActivity
	ActivitystreamsActivityTargetNote
	ActivitystreamsActivityTargetUser
	ActivitystreamsActivityTargetBoost
	ActivitystreamsActivityTargetReaction
	ActivitystreamsActivityTargetFollow
)

func (n *ActivitystreamsActivityTargetType) Value() (driver.Value, error) {
	return n, nil
}

func (ct *ActivitystreamsActivityTargetType) Scan(value any) error {
	*ct = ActivitystreamsActivityTargetType(value.(uint32))
	return nil
}

var AllActivitystreamsActivityTargetTypes = []ActivitystreamsActivityTargetType{
	ActivitystreamsActivityTargetUnknown,
	ActivitystreamsActivityTargetActivity,
	ActivitystreamsActivityTargetNote,
	ActivitystreamsActivityTargetUser,
	ActivitystreamsActivityTargetBoost,
	ActivitystreamsActivityTargetReaction,
	ActivitystreamsActivityTargetFollow,
}
