package models

import "database/sql/driver"

type ActivitystreamsObjectType string

const (
	ObjectTypeUnknown      = ActivitystreamsObjectType("unknown")
	ObjectTypeArticle      = ActivitystreamsObjectType("article")
	ObjectTypeAudio        = ActivitystreamsObjectType("audio")
	ObjectTypeDocument     = ActivitystreamsObjectType("document")
	ObjectTypeEvent        = ActivitystreamsObjectType("event")
	ObjectTypeImage        = ActivitystreamsObjectType("image")
	ObjectTypeNote         = ActivitystreamsObjectType("note")
	ObjectTypePage         = ActivitystreamsObjectType("page")
	ObjectTypePlace        = ActivitystreamsObjectType("place")
	ObjectTypeProfile      = ActivitystreamsObjectType("profile")
	ObjectTypeRelationship = ActivitystreamsObjectType("relationsjip")
	ObjectTypeTombstone    = ActivitystreamsObjectType("tombstone")
	ObjectTypeVideo        = ActivitystreamsObjectType("video")
)

var AllActivitystreamsObjectTypes = []ActivitystreamsObjectType{
	ObjectTypeUnknown,
	ObjectTypeArticle,
	ObjectTypeAudio,
	ObjectTypeDocument,
	ObjectTypeEvent,
	ObjectTypeImage,
	ObjectTypeNote,
	ObjectTypePage,
	ObjectTypePlace,
	ObjectTypeProfile,
	ObjectTypeRelationship,
	ObjectTypeTombstone,
	ObjectTypeVideo,
}

func (r *ActivitystreamsObjectType) Value() (driver.Value, error) {
	return r, nil
}

func (ct *ActivitystreamsObjectType) Scan(value any) error {
	*ct = ActivitystreamsObjectType(value.(string))
	return nil
}
