// Code generated by cmd/RolesGenerator DO NOT EDIT.
// If you need to refresh the content, run go generate again
package storage

import (
  "slices"
  "git.mstar.dev/mstar/goutils/sliceutils"
    "git.mstar.dev/mstar/linstrom/storage-new/models"
)

// CollapseRolesIntoOne takes a list of roles and collapses them down into one.
// It ensures to follow the priority of each role.
// All results will use [models.DefaultUserRole] as the baseline.
// The resulting role will have each entry filled with the value of the highest priority.
// If multiple roles have the same priority, the order in which they are applied is not stable.
func CollapseRolesIntoOne(roles ...models.Role) models.Role {
  startingRole := RoleDeepCopy(models.DefaultUserRole)
  slices.SortFunc(roles, func(a, b models.Role) int { return int(int64(a.Priority)-int64(b.Priority)) })
  for _, role := range roles {
    if role.CanMentionOthers != nil {
      *startingRole.CanMentionOthers = *role.CanMentionOthers
    }
    if role.WithholdNotesBasedOnRegex != nil {
      *startingRole.WithholdNotesBasedOnRegex = *role.WithholdNotesBasedOnRegex
    }
    if role.CanManageCustomEmotes != nil {
      *startingRole.CanManageCustomEmotes = *role.CanManageCustomEmotes
    }
    if role.CanSendMedia != nil {
      *startingRole.CanSendMedia = *role.CanSendMedia
    }
    if role.CanSendFollowerOnlyNotes != nil {
      *startingRole.CanSendFollowerOnlyNotes = *role.CanSendFollowerOnlyNotes
    }
    if role.CanSendReplies != nil {
      *startingRole.CanSendReplies = *role.CanSendReplies
    }
    if role.CanIncludeLinks != nil {
      *startingRole.CanIncludeLinks = *role.CanIncludeLinks
    }
    if role.CanSubmitReports != nil {
      *startingRole.CanSubmitReports = *role.CanSubmitReports
    }
    if role.CanQuote != nil {
      *startingRole.CanQuote = *role.CanQuote
    }
    if role.CanChangeDisplayName != nil {
      *startingRole.CanChangeDisplayName = *role.CanChangeDisplayName
    }
    if role.ScanCreatedPublicNotes != nil {
      *startingRole.ScanCreatedPublicNotes = *role.ScanCreatedPublicNotes
    }
    if role.CanSupressInteractionsBetweenUsers != nil {
      *startingRole.CanSupressInteractionsBetweenUsers = *role.CanSupressInteractionsBetweenUsers
    }
    if role.WithholdNotesForManualApproval != nil {
      *startingRole.WithholdNotesForManualApproval = *role.WithholdNotesForManualApproval
    }
    if role.CanRecoverDeletedNotes != nil {
      *startingRole.CanRecoverDeletedNotes = *role.CanRecoverDeletedNotes
    }
    if role.CanManageAds != nil {
      *startingRole.CanManageAds = *role.CanManageAds
    }
    if role.CanSendCustomEmotes != nil {
      *startingRole.CanSendCustomEmotes = *role.CanSendCustomEmotes
    }
    if role.CanIncludeSurvey != nil {
      *startingRole.CanIncludeSurvey = *role.CanIncludeSurvey
    }
    if role.MentionLimit != nil {
      *startingRole.MentionLimit = *role.MentionLimit
    }
    if role.AutoCwPosts != nil {
      *startingRole.AutoCwPosts = *role.AutoCwPosts
    }
    if role.ScanCreatedFollowerOnlyNotes != nil {
      *startingRole.ScanCreatedFollowerOnlyNotes = *role.ScanCreatedFollowerOnlyNotes
    }
    if role.HasMentionCountLimit != nil {
      *startingRole.HasMentionCountLimit = *role.HasMentionCountLimit
    }
    if role.CanAffectOtherAdmins != nil {
      *startingRole.CanAffectOtherAdmins = *role.CanAffectOtherAdmins
    }
    if role.CanDeleteNotes != nil {
      *startingRole.CanDeleteNotes = *role.CanDeleteNotes
    }
    if role.CanOverwriteDisplayNames != nil {
      *startingRole.CanOverwriteDisplayNames = *role.CanOverwriteDisplayNames
    }
    if role.CanDeleteAccounts != nil {
      *startingRole.CanDeleteAccounts = *role.CanDeleteAccounts
    }
    if role.CanSendPublicNotes != nil {
      *startingRole.CanSendPublicNotes = *role.CanSendPublicNotes
    }
    if role.CanSendLocalNotes != nil {
      *startingRole.CanSendLocalNotes = *role.CanSendLocalNotes
    }
    if role.DisallowInteractionsWith != nil {
      startingRole.DisallowInteractionsWith = append(startingRole.DisallowInteractionsWith, role.DisallowInteractionsWith...)
    }
    if role.CanViewDeletedNotes != nil {
      *startingRole.CanViewDeletedNotes = *role.CanViewDeletedNotes
    }
    if role.CanManageAvatarDecorations != nil {
      *startingRole.CanManageAvatarDecorations = *role.CanManageAvatarDecorations
    }
    if role.CanAssignRoles != nil {
      *startingRole.CanAssignRoles = *role.CanAssignRoles
    }
    if role.CanSendCustomReactions != nil {
      *startingRole.CanSendCustomReactions = *role.CanSendCustomReactions
    }
    if role.CanBoost != nil {
      *startingRole.CanBoost = *role.CanBoost
    }
    if role.CanFederateFedi != nil {
      *startingRole.CanFederateFedi = *role.CanFederateFedi
    }
    if role.CanLogin != nil {
      *startingRole.CanLogin = *role.CanLogin
    }
    if role.CanConfirmWithheldNotes != nil {
      *startingRole.CanConfirmWithheldNotes = *role.CanConfirmWithheldNotes
    }
    if role.CanFederateBsky != nil {
      *startingRole.CanFederateBsky = *role.CanFederateBsky
    }
    if role.AutoCwPostsText != nil {
      *startingRole.AutoCwPostsText = *role.AutoCwPostsText
    }
    if role.FullAdmin != nil {
      *startingRole.FullAdmin = *role.FullAdmin
    }
    if role.CanSendAnnouncements != nil {
      *startingRole.CanSendAnnouncements = *role.CanSendAnnouncements
    }
    if role.CanSendPrivateNotes != nil {
      *startingRole.CanSendPrivateNotes = *role.CanSendPrivateNotes
    }
    if role.AutoNsfwMedia != nil {
      *startingRole.AutoNsfwMedia = *role.AutoNsfwMedia
    }
    if role.ScanCreatedLocalNotes != nil {
      *startingRole.ScanCreatedLocalNotes = *role.ScanCreatedLocalNotes
    }
    if role.ScanCreatedPrivateNotes != nil {
      *startingRole.ScanCreatedPrivateNotes = *role.ScanCreatedPrivateNotes
    }
    if role.WithholdNotesRegexes != nil {
      startingRole.WithholdNotesRegexes = append(startingRole.WithholdNotesRegexes, role.WithholdNotesRegexes...)
    }
  }
  return startingRole
}

// RoleDeepCopy performs a deep copy of a given role.
// Each element will point to a newly stored value.
// The new and old role will contain identical information.
func RoleDeepCopy(o models.Role) models.Role {
  n := models.Role{}
  n.Model = o.Model
  n.Name = o.Name
  n.Priority = o.Priority
  n.IsUserRole = o.IsUserRole
  n.IsBuiltIn = o.IsBuiltIn
  if o.FullAdmin == nil { n.FullAdmin = nil } else {
      t := *o.FullAdmin
      n.FullAdmin = &t
    }
  if o.CanSendAnnouncements == nil { n.CanSendAnnouncements = nil } else {
      t := *o.CanSendAnnouncements
      n.CanSendAnnouncements = &t
    }
  if o.CanFederateBsky == nil { n.CanFederateBsky = nil } else {
      t := *o.CanFederateBsky
      n.CanFederateBsky = &t
    }
  if o.AutoCwPostsText == nil { n.AutoCwPostsText = nil } else {
      t := *o.AutoCwPostsText
      n.AutoCwPostsText = &t
    }
  if o.ScanCreatedLocalNotes == nil { n.ScanCreatedLocalNotes = nil } else {
      t := *o.ScanCreatedLocalNotes
      n.ScanCreatedLocalNotes = &t
    }
  if o.ScanCreatedPrivateNotes == nil { n.ScanCreatedPrivateNotes = nil } else {
      t := *o.ScanCreatedPrivateNotes
      n.ScanCreatedPrivateNotes = &t
    }
  n.WithholdNotesRegexes = slices.Clone(o.WithholdNotesRegexes)
  if o.CanSendPrivateNotes == nil { n.CanSendPrivateNotes = nil } else {
      t := *o.CanSendPrivateNotes
      n.CanSendPrivateNotes = &t
    }
  if o.AutoNsfwMedia == nil { n.AutoNsfwMedia = nil } else {
      t := *o.AutoNsfwMedia
      n.AutoNsfwMedia = &t
    }
  if o.CanSendReplies == nil { n.CanSendReplies = nil } else {
      t := *o.CanSendReplies
      n.CanSendReplies = &t
    }
  if o.CanIncludeLinks == nil { n.CanIncludeLinks = nil } else {
      t := *o.CanIncludeLinks
      n.CanIncludeLinks = &t
    }
  if o.CanSubmitReports == nil { n.CanSubmitReports = nil } else {
      t := *o.CanSubmitReports
      n.CanSubmitReports = &t
    }
  if o.CanMentionOthers == nil { n.CanMentionOthers = nil } else {
      t := *o.CanMentionOthers
      n.CanMentionOthers = &t
    }
  if o.WithholdNotesBasedOnRegex == nil { n.WithholdNotesBasedOnRegex = nil } else {
      t := *o.WithholdNotesBasedOnRegex
      n.WithholdNotesBasedOnRegex = &t
    }
  if o.CanManageCustomEmotes == nil { n.CanManageCustomEmotes = nil } else {
      t := *o.CanManageCustomEmotes
      n.CanManageCustomEmotes = &t
    }
  if o.CanSendMedia == nil { n.CanSendMedia = nil } else {
      t := *o.CanSendMedia
      n.CanSendMedia = &t
    }
  if o.CanSendFollowerOnlyNotes == nil { n.CanSendFollowerOnlyNotes = nil } else {
      t := *o.CanSendFollowerOnlyNotes
      n.CanSendFollowerOnlyNotes = &t
    }
  if o.ScanCreatedPublicNotes == nil { n.ScanCreatedPublicNotes = nil } else {
      t := *o.ScanCreatedPublicNotes
      n.ScanCreatedPublicNotes = &t
    }
  if o.CanSupressInteractionsBetweenUsers == nil { n.CanSupressInteractionsBetweenUsers = nil } else {
      t := *o.CanSupressInteractionsBetweenUsers
      n.CanSupressInteractionsBetweenUsers = &t
    }
  if o.CanQuote == nil { n.CanQuote = nil } else {
      t := *o.CanQuote
      n.CanQuote = &t
    }
  if o.CanChangeDisplayName == nil { n.CanChangeDisplayName = nil } else {
      t := *o.CanChangeDisplayName
      n.CanChangeDisplayName = &t
    }
  if o.MentionLimit == nil { n.MentionLimit = nil } else {
      t := *o.MentionLimit
      n.MentionLimit = &t
    }
  if o.AutoCwPosts == nil { n.AutoCwPosts = nil } else {
      t := *o.AutoCwPosts
      n.AutoCwPosts = &t
    }
  if o.ScanCreatedFollowerOnlyNotes == nil { n.ScanCreatedFollowerOnlyNotes = nil } else {
      t := *o.ScanCreatedFollowerOnlyNotes
      n.ScanCreatedFollowerOnlyNotes = &t
    }
  if o.WithholdNotesForManualApproval == nil { n.WithholdNotesForManualApproval = nil } else {
      t := *o.WithholdNotesForManualApproval
      n.WithholdNotesForManualApproval = &t
    }
  if o.CanRecoverDeletedNotes == nil { n.CanRecoverDeletedNotes = nil } else {
      t := *o.CanRecoverDeletedNotes
      n.CanRecoverDeletedNotes = &t
    }
  if o.CanManageAds == nil { n.CanManageAds = nil } else {
      t := *o.CanManageAds
      n.CanManageAds = &t
    }
  if o.CanSendCustomEmotes == nil { n.CanSendCustomEmotes = nil } else {
      t := *o.CanSendCustomEmotes
      n.CanSendCustomEmotes = &t
    }
  if o.CanIncludeSurvey == nil { n.CanIncludeSurvey = nil } else {
      t := *o.CanIncludeSurvey
      n.CanIncludeSurvey = &t
    }
  if o.CanDeleteNotes == nil { n.CanDeleteNotes = nil } else {
      t := *o.CanDeleteNotes
      n.CanDeleteNotes = &t
    }
  if o.CanOverwriteDisplayNames == nil { n.CanOverwriteDisplayNames = nil } else {
      t := *o.CanOverwriteDisplayNames
      n.CanOverwriteDisplayNames = &t
    }
  if o.CanDeleteAccounts == nil { n.CanDeleteAccounts = nil } else {
      t := *o.CanDeleteAccounts
      n.CanDeleteAccounts = &t
    }
  if o.HasMentionCountLimit == nil { n.HasMentionCountLimit = nil } else {
      t := *o.HasMentionCountLimit
      n.HasMentionCountLimit = &t
    }
  if o.CanAffectOtherAdmins == nil { n.CanAffectOtherAdmins = nil } else {
      t := *o.CanAffectOtherAdmins
      n.CanAffectOtherAdmins = &t
    }
  n.DisallowInteractionsWith = slices.Clone(o.DisallowInteractionsWith)
  if o.CanViewDeletedNotes == nil { n.CanViewDeletedNotes = nil } else {
      t := *o.CanViewDeletedNotes
      n.CanViewDeletedNotes = &t
    }
  if o.CanManageAvatarDecorations == nil { n.CanManageAvatarDecorations = nil } else {
      t := *o.CanManageAvatarDecorations
      n.CanManageAvatarDecorations = &t
    }
  if o.CanSendPublicNotes == nil { n.CanSendPublicNotes = nil } else {
      t := *o.CanSendPublicNotes
      n.CanSendPublicNotes = &t
    }
  if o.CanSendLocalNotes == nil { n.CanSendLocalNotes = nil } else {
      t := *o.CanSendLocalNotes
      n.CanSendLocalNotes = &t
    }
  if o.CanFederateFedi == nil { n.CanFederateFedi = nil } else {
      t := *o.CanFederateFedi
      n.CanFederateFedi = &t
    }
  if o.CanLogin == nil { n.CanLogin = nil } else {
      t := *o.CanLogin
      n.CanLogin = &t
    }
  if o.CanConfirmWithheldNotes == nil { n.CanConfirmWithheldNotes = nil } else {
      t := *o.CanConfirmWithheldNotes
      n.CanConfirmWithheldNotes = &t
    }
  if o.CanAssignRoles == nil { n.CanAssignRoles = nil } else {
      t := *o.CanAssignRoles
      n.CanAssignRoles = &t
    }
  if o.CanSendCustomReactions == nil { n.CanSendCustomReactions = nil } else {
      t := *o.CanSendCustomReactions
      n.CanSendCustomReactions = &t
    }
  if o.CanBoost == nil { n.CanBoost = nil } else {
      t := *o.CanBoost
      n.CanBoost = &t
    }
  return n
}

// Compare two roles for equality.
// If a permission is nil in one of the roles, that permission is ignored.
func CompareRoles(a, b *models.Role) bool {
  return (a.CanSendPrivateNotes == nil || b.CanSendPrivateNotes == nil || a.CanSendPrivateNotes == b.CanSendPrivateNotes) && (a.AutoNsfwMedia == nil || b.AutoNsfwMedia == nil || a.AutoNsfwMedia == b.AutoNsfwMedia) && (a.ScanCreatedLocalNotes == nil || b.ScanCreatedLocalNotes == nil || a.ScanCreatedLocalNotes == b.ScanCreatedLocalNotes) && (a.ScanCreatedPrivateNotes == nil || b.ScanCreatedPrivateNotes == nil || a.ScanCreatedPrivateNotes == b.ScanCreatedPrivateNotes) && (a.WithholdNotesRegexes == nil || b.WithholdNotesRegexes == nil || sliceutils.CompareUnordered(a.WithholdNotesRegexes,b.WithholdNotesRegexes)) && (a.CanSendMedia == nil || b.CanSendMedia == nil || a.CanSendMedia == b.CanSendMedia) && (a.CanSendFollowerOnlyNotes == nil || b.CanSendFollowerOnlyNotes == nil || a.CanSendFollowerOnlyNotes == b.CanSendFollowerOnlyNotes) && (a.CanSendReplies == nil || b.CanSendReplies == nil || a.CanSendReplies == b.CanSendReplies) && (a.CanIncludeLinks == nil || b.CanIncludeLinks == nil || a.CanIncludeLinks == b.CanIncludeLinks) && (a.CanSubmitReports == nil || b.CanSubmitReports == nil || a.CanSubmitReports == b.CanSubmitReports) && (a.CanMentionOthers == nil || b.CanMentionOthers == nil || a.CanMentionOthers == b.CanMentionOthers) && (a.WithholdNotesBasedOnRegex == nil || b.WithholdNotesBasedOnRegex == nil || a.WithholdNotesBasedOnRegex == b.WithholdNotesBasedOnRegex) && (a.CanManageCustomEmotes == nil || b.CanManageCustomEmotes == nil || a.CanManageCustomEmotes == b.CanManageCustomEmotes) && (a.CanQuote == nil || b.CanQuote == nil || a.CanQuote == b.CanQuote) && (a.CanChangeDisplayName == nil || b.CanChangeDisplayName == nil || a.CanChangeDisplayName == b.CanChangeDisplayName) && (a.ScanCreatedPublicNotes == nil || b.ScanCreatedPublicNotes == nil || a.ScanCreatedPublicNotes == b.ScanCreatedPublicNotes) && (a.CanSupressInteractionsBetweenUsers == nil || b.CanSupressInteractionsBetweenUsers == nil || a.CanSupressInteractionsBetweenUsers == b.CanSupressInteractionsBetweenUsers) && (a.CanSendCustomEmotes == nil || b.CanSendCustomEmotes == nil || a.CanSendCustomEmotes == b.CanSendCustomEmotes) && (a.CanIncludeSurvey == nil || b.CanIncludeSurvey == nil || a.CanIncludeSurvey == b.CanIncludeSurvey) && (a.MentionLimit == nil || b.MentionLimit == nil || a.MentionLimit == b.MentionLimit) && (a.AutoCwPosts == nil || b.AutoCwPosts == nil || a.AutoCwPosts == b.AutoCwPosts) && (a.ScanCreatedFollowerOnlyNotes == nil || b.ScanCreatedFollowerOnlyNotes == nil || a.ScanCreatedFollowerOnlyNotes == b.ScanCreatedFollowerOnlyNotes) && (a.WithholdNotesForManualApproval == nil || b.WithholdNotesForManualApproval == nil || a.WithholdNotesForManualApproval == b.WithholdNotesForManualApproval) && (a.CanRecoverDeletedNotes == nil || b.CanRecoverDeletedNotes == nil || a.CanRecoverDeletedNotes == b.CanRecoverDeletedNotes) && (a.CanManageAds == nil || b.CanManageAds == nil || a.CanManageAds == b.CanManageAds) && (a.HasMentionCountLimit == nil || b.HasMentionCountLimit == nil || a.HasMentionCountLimit == b.HasMentionCountLimit) && (a.CanAffectOtherAdmins == nil || b.CanAffectOtherAdmins == nil || a.CanAffectOtherAdmins == b.CanAffectOtherAdmins) && (a.CanDeleteNotes == nil || b.CanDeleteNotes == nil || a.CanDeleteNotes == b.CanDeleteNotes) && (a.CanOverwriteDisplayNames == nil || b.CanOverwriteDisplayNames == nil || a.CanOverwriteDisplayNames == b.CanOverwriteDisplayNames) && (a.CanDeleteAccounts == nil || b.CanDeleteAccounts == nil || a.CanDeleteAccounts == b.CanDeleteAccounts) && (a.CanSendPublicNotes == nil || b.CanSendPublicNotes == nil || a.CanSendPublicNotes == b.CanSendPublicNotes) && (a.CanSendLocalNotes == nil || b.CanSendLocalNotes == nil || a.CanSendLocalNotes == b.CanSendLocalNotes) && (a.DisallowInteractionsWith == nil || b.DisallowInteractionsWith == nil || sliceutils.CompareUnordered(a.DisallowInteractionsWith,b.DisallowInteractionsWith)) && (a.CanViewDeletedNotes == nil || b.CanViewDeletedNotes == nil || a.CanViewDeletedNotes == b.CanViewDeletedNotes) && (a.CanManageAvatarDecorations == nil || b.CanManageAvatarDecorations == nil || a.CanManageAvatarDecorations == b.CanManageAvatarDecorations) && (a.CanSendCustomReactions == nil || b.CanSendCustomReactions == nil || a.CanSendCustomReactions == b.CanSendCustomReactions) && (a.CanBoost == nil || b.CanBoost == nil || a.CanBoost == b.CanBoost) && (a.CanFederateFedi == nil || b.CanFederateFedi == nil || a.CanFederateFedi == b.CanFederateFedi) && (a.CanLogin == nil || b.CanLogin == nil || a.CanLogin == b.CanLogin) && (a.CanConfirmWithheldNotes == nil || b.CanConfirmWithheldNotes == nil || a.CanConfirmWithheldNotes == b.CanConfirmWithheldNotes) && (a.CanAssignRoles == nil || b.CanAssignRoles == nil || a.CanAssignRoles == b.CanAssignRoles) && (a.CanFederateBsky == nil || b.CanFederateBsky == nil || a.CanFederateBsky == b.CanFederateBsky) && (a.AutoCwPostsText == nil || b.AutoCwPostsText == nil || a.AutoCwPostsText == b.AutoCwPostsText) && (a.FullAdmin == nil || b.FullAdmin == nil || a.FullAdmin == b.FullAdmin) && (a.CanSendAnnouncements == nil || b.CanSendAnnouncements == nil || a.CanSendAnnouncements == b.CanSendAnnouncements) && (a == nil || b == nil || a.CanSendAnnouncements == b.CanSendAnnouncements)
}