package activitypub

import (
	"net/http"
)

func BuildActivitypubRouter() http.Handler {
	router := http.NewServeMux()
	router.HandleFunc("/user/{id}", users)
	router.HandleFunc("/user/{id}/inbox", userInbox)
	router.HandleFunc("/user/{id}/followers", userFollowers)
	router.HandleFunc("/user/{id}/following", userFollowing)
	router.HandleFunc("/activity/accept/{id}", activityAccept)
	router.HandleFunc("/activity/create/{id}", activityCreate)
	router.HandleFunc("/activity/delete/{id}", activityDelete)
	router.HandleFunc("/activity/reject/{id}", activityReject)
	router.HandleFunc("/activity/update/{id}", activityUpdate)
	router.HandleFunc("/note/{id}", objectNote)
	return router
}
